# fastapi-listing

An Advanced Data Listing Library for fastapi

[![.github/workflows/deploy.yml](https://github.com/danielhasan1/fastapi-listing/actions/workflows/deploy.yml/badge.svg)](https://github.com/danielhasan1/fastapi-listing/actions/workflows/deploy.yml)
[![.github/workflows/tests.yml](https://github.com/danielhasan1/fastapi-listing/actions/workflows/tests.yml/badge.svg)](https://github.com/danielhasan1/fastapi-listing/actions/workflows/tests.yml) ![PyPI - Programming Language](https://img.shields.io/pypi/pyversions/fastapi-listing.svg?color=%2334D058)
[![codecov](https://codecov.io/gh/danielhasan1/fastapi-listing/branch/dev/graph/badge.svg?token=U29ZRNAH8I)](https://codecov.io/gh/danielhasan1/fastapi-listing)

The FastAPI Listing Library is a Python library for building fast, flexible, and customizable listing views in FastAPI web applications. It allows you to easily define listing views for your data models and customize the behavior of those views with minimal code.
## Features

 - Easy-to-use API for listing and formatting data
 - Customize infinitely(Challenge your design principles)
 - Built-in support for pagination, sorting and filtering
 - Built-in support for SQLAlchemy
 - Well defined interface for filter, sorter, paginator
 - The most decoupled API
 - A built-in **semantic** for getting **filters/sorting parameters from clients**
 - Extend anything, swap modules on the fly write n number of versions/strategies
 - The most dry approach you will ever see and create
 - Available adapters allow you to add support for existing client site dependency
 - loaded with features, write the most complex listings api with ease


# Documentation
View full documentation at: https://fastapi-listing.readthedocs.io/


# Feedback, Questions?

Any form of feedback and questions are welcome! Please create an issue
[here](https://github.com/danielhasan1/fastapi-listing/issues/new).